<template>
    <div style="display:flex;min-height:100vh;max-height:100vh;min-width:100vw;max-width:100vw">
        <sidebar></sidebar>
        <div style="flex:1 1 auto; display:flex; flex-direction:column;height:100vh;">
            <topbar></topbar>
            <el-container style="flex: 1 1 auto; overflow:auto">
                <el-main>
                    <el-button
                        v-on:click="ping">Ping</el-button>
                    <router-view name="content"></router-view>
                </el-main>
            </el-container>
        </div>
        <login></login>
    </div>
</template>
<style scoped>
body {
    background-color:#eee
}
.el-main {
    overflow: unset;
}
</style>
<script>
// TODO
// Prevent menu navigation while logged out via "TAB" keypress
"use strict";

import Sidebar from "./layout/sidebar.vue";
import Sidebar2 from "./layout/sidebar2.vue";
import Topbar from "./layout/topbar.vue";
import Login from "./view/login.vue";

export default {
    name: "Main",
    components: {Sidebar, Sidebar2, Topbar, Login},
    data() {
        return {
            sidebarCollapsed: true,
        };
    },
    created() {
        this.documentTitlesCompute();
    },
    mounted() {
        // It's a separated method because on first page load the watcher doesn't trigger
        this.documentTitleUpdate();
        this.ping();
    },
    watch: {
        documentTitle() {
            this.documentTitleUpdate();
        }
    },
    computed: {
        // Whenever route changes, we look into route metadata the path for the title traduction
        documentTitle() {
            return this.$route.meta.title;
        },
        // On sidebar collapse, everything else resizes accordingly
        sidebarWidth() {
            return this.sidebarCollapsed ? 1 : 6;
        }
    },
    methods: {
        ping() {
            console.log("ping");
            this.$store.dispatch("ping");
        },
        documentTitlesCompute() {
            this.$router.options.routes.forEach((route) => {
                route.meta.title = this.$t(route.meta.pathTitle, {appName: this.$t("shared.app.title")});
            });
        },
        documentTitleUpdate() {
            window.document.title = this.documentTitle || this.$route.meta.title || this.$t("shared.app.title");
        },
        sidebarCollapse() {
            this.sidebarCollapsed = !this.sidebarCollapsed;
        }
    }
};
</script>
